define([], function() {

			function getWidthHeightP2(width, height) {
				var max = Math.max(width, height);
				for(var needWh = 1; needWh < 70000; needWh <<= 1) {
					if ( needWh >= max ) { break; }
				}			
				return {width: needWh, height: needWh};
			}
			function createCanvas(width, height, isContext, isImageData) {
				var obj = {};
				obj.width     = width;
				obj.height    = height;
				obj.canvas    = document.createElement("canvas");
				obj.canvas.width  = width;
				obj.canvas.height = height;
				if ( isContext ) {
					obj.context2d = obj.canvas.getContext("2d");
				}
				if ( isImageData ) {
					obj.imageData     = obj.context2d.getImageData(0, 0, width, height);
				}
				return obj;
			}
			function setWrapTexture(name, imageData) {
				var texture = {
					//image: image,
					imageData:   imageData,
					width:       imageData.width,
					height:      imageData.height,
					texture:     gl.createTexture(),
					translucent: name == "aaatrigger"
				};

				gl.bindTexture(gl.TEXTURE_2D, texture.texture);
				//gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, texture.width, texture.height, 0, gl.RGBA, gl.UNSIGNED_BYTE, texture.imageData.data);
				gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, texture.imageData);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);

				HLBSP.Textures[mipTex.szname] = texture;		
			}
			function readNewTexture(name, buffer) {
				var width  = (new DataView(buffer)).getInt32(0*4, true);
				var height = (new DataView(buffer)).getInt32(1*4, true);
				
				var pixels = new Uint8Array(buffer, 8);
				var pals   = new Uint8Array(buffer, 8 + width * height);
				
				var cnvOrigin = createCanvas(width, height, 1,1);
				var ctxData = cnvOrigin.imageData.data;
				
				var trns = ( name && name[0] === "{" );
				
				for(var y = 0; y < height; y++) {
					var yw = y * width;
				
					for(var x = 0; x < width; x++) {
						var ywx = yw + x;
						
						var palIndex = pixels[ywx] * 3;
			
						var r = pals[ palIndex + 0 ];
						var g = pals[ palIndex + 1 ];
						var b = pals[ palIndex + 2 ];
						
						ctxData[ywx*4 + 0] = r;
						ctxData[ywx*4 + 1] = g;
						ctxData[ywx*4 + 2] = b;
						ctxData[ywx*4 + 3] = 255;

						if ( trns && palIndex === 255*3 && r === 0 && g === 0 && b === 255 ) {
							ctxData[ywx*4 + 3] = 0;
						}
					}
				}
				
				cnvOrigin.context2d.putImageData(cnvOrigin.imageData, 0, 0);

				var finalWh = getWidthHeightP2(width, height);
				var cnvFinal = createCanvas(finalWh.width, finalWh.height, 1);
				cnvFinal.context2d.drawImage(cnvOrigin.canvas, 0, 0, cnvFinal.width, cnvFinal.height);

				return cnvFinal.context2d.getImageData(0, 0, cnvFinal.width, cnvFinal.height);				
			}
			function readTexture(mipTex, buffer, attrs) {
				var width  = mipTex.width;
				var height = mipTex.height;
				
				var cnvOrigin = createCanvas(width, height, 1,1);
				var ctxData = cnvOrigin.imageData.data;

				var offsetRGBPal = mipTex.offsets[3] + ((width / 8) * (height / 8)) + 2;
				
				var trns = ( mipTex.szname && mipTex.szname[0] === "{" );
				
				
				//--------------
				if ( attrs && attrs.setTexture ) {
					var new_Texture = new ArrayBuffer( 4*2 + height*width + 256*3 );

					(new DataView(new_Texture)).setInt32(0*4, width , true);
					(new DataView(new_Texture)).setInt32(1*4, height, true);
					
					(new Uint8Array(new_Texture, 4*2)).set(
						buffer.subarray(mipTex.offsets[0], mipTex.offsets[0] + width * height)
					);
					
					(new Uint8Array(new_Texture, 4*2 + height*width)).set(
						buffer.subarray(offsetRGBPal, offsetRGBPal + 256*3)
					);
					attrs.texture = new_Texture;
				}
				//--------------
				
				for(var i = 0; i < 4; i++) {
					var offset = mipTex.offsets[i];
					
					for(var y = 0; y < height; y++) {
						var yw = y * width;
						
						for(var x = 0; x < width; x++) {
							var ywx = yw + x;
							var j = offset + ywx;
							
							var palIndex = buffer[j] * 3;
							
							var r = buffer[ offsetRGBPal + palIndex + 0 ];
							var g = buffer[ offsetRGBPal + palIndex + 1 ];
							var b = buffer[ offsetRGBPal + palIndex + 2 ];
						
							ctxData[ywx*4 + 0] = r;
							ctxData[ywx*4 + 1] = g;
							ctxData[ywx*4 + 2] = b;
							ctxData[ywx*4 + 3] = 255;
							
							if ( trns && palIndex === 255*3 && r === 0 && g === 0 && b === 255 ) {
								ctxData[ywx*4 + 3] = 0;
							}
						}
					}
					
					break;
				}
				


				cnvOrigin.context2d.putImageData(cnvOrigin.imageData, 0, 0);

				var finalWh = getWidthHeightP2(width, height);
				var cnvFinal = createCanvas(finalWh.width, finalWh.height, 1);
				cnvFinal.context2d.drawImage(cnvOrigin.canvas, 0, 0, cnvFinal.width, cnvFinal.height);

				return cnvFinal.context2d.getImageData(0, 0, cnvFinal.width, cnvFinal.height);
			}
			
			return {
				readTexture: readTexture,
				readNewTexture: readNewTexture,
			};

});