define(['jquery'], function($) {
	
	function ShowFps(showInterval, $container) {
		this.showInterval = (showInterval || 1) * 1e3;

		this.fps_count = 0;
		this.prev_time = false;

		this.$container = $container;
		
		this.initShowElem();
		
		var self = this;
		this.frame = function() {
			var time = performance.now();

			if ( self.prev_time !== false ) {
				self.fps_count++;
				
				if ( time < self.prev_time ) {
					return;
				}
				
				var time_delta = time - self.prev_time + self.showInterval;
				var fps = self.fps_count / (time_delta*1e-3);
				self.show(fps);
			}
			
			self.fps_count = 0;
			self.prev_time = time + self.showInterval;
		}
	}
	ShowFps.prototype.initShowElem = function() {
		var $fps_group = $('.gui-fps-show-group-cl');
		
		
		if ( !$fps_group.length ) {
			$fps_group = $('<div class="gui-fps-show-group-cl">').css({
				position: 'absolute',
				top: '20px',
				left: '20px',
				'box-shadow': 'inset 0px 0px 5px #FFF',
				'padding': '5px',
				color: '#fff',
				'font-family': 'Caption',
				background: '#000',
				'min-width': '30px',
				'text-align': 'center',
				'border-radius': '5px',
				'user-select': 'none',
				'cursor': 'pointer'
			});

			this.$container.append($fps_group);
		}

		this.$fps = $('<div>');
		this.$fps.css({
			'box-shadow': 'inset 0px 0px 5px #FFF',
			'padding': '5px',
			margin: '5px',
			'float': 'left',
			color: '#fff',
			'font-family': 'Caption',
			background: '#000',
			'min-width': '30px',
			'text-align': 'center',
			'border-radius': '5px',
			'user-select': 'none',
			'cursor': 'pointer'
		});
		
		$fps_group.append(this.$fps);
	}
	ShowFps.prototype.show = function(fps) {
		this.$fps.html( fps.toFixed(0) );
	}
	/*
	ShowFps.prototype.frame = function() {
		var time = performance.now();

		if ( this.prev_time !== false ) {
			this.fps_count++;
			
			if ( time < this.prev_time ) {
				return;
			}
			
			var time_delta = time - this.prev_time + this.showInterval;
			var fps = this.fps_count / (time_delta*1e-3);
			this.show(fps);
		}
		
		this.fps_count = 0;
		this.prev_time = time + this.showInterval;
	}
	*/
	return ShowFps;
	
});