define(['lib/zip'], function(zip) {

	zip.useWebWorkers = true;
	zip.workerScriptsPath = 'js/lib/zip/';
		
	function ZipSimplie(config) {
		this.config = config || {};
		
		this.zipFs = new zip.fs.FS();
	}
	ZipSimplie.prototype.parsePath = function(path) {
		if ( this.config.pathToLowerCase ) {
			path = path.toLowerCase();
		}
		var list = path.replace('\\','/').match(/[^/]+/g);
		if ( !list ) { 
			list = [];
		}
		
		list = list.map(function(val) {
			return val.trim();
		}).filter(function(val) {
			return val.length > 0;
		});
		return list;
	}
	ZipSimplie.prototype.file_write = function(path, blob) {
		var list = this.parsePath(path);
		if ( !list.length ) {
			throw "Zip error. Path is empty";
		}
		
		var dir = this.create_dirs(path);
		
		var filename = list[ list.length-1 ];
		if ( dir.getChildByName(filename) ) {
			throw ("Zip error. Path '"+path+"', '"+filename+"' is exists");
		}
		
		dir.addBlob(filename, blob);
	}
	ZipSimplie.prototype.create_dirs = function(path) {
		var list = this.parsePath(path);
		
		var node = this.zipFs.root;
		for(var i = 0; i < list.length - 1; i++) {
			var dir = list[i];
			var _node = node.getChildByName(dir);
			node = _node ? _node : node.addDirectory(dir);
			if ( !node.directory ) {
				throw ("Zip error. Path '"+path+"', '"+dir+"' is not dir");
			}
		}
		
		return node;
	}
	ZipSimplie.prototype.exportBlob = function() {
		this.zipFs.exportBlob.apply(this.zipFs, arguments);
	}

	return ZipSimplie;

});