define([], function() {

	function FilesManager() {
		this.files = [];
		
		this.trySame = true;
		
		this.filters = [];
		
		this.exts = [];
		
		this.inputFile = document.createElement('input');
		this.inputFile.type = 'file';
		this.inputFile.multiple = '1';
		this.inputFile.accept = '*';
		this.inputFile.style.display = 'none';
		
		document.body.appendChild(this.inputFile);
		
		this.addDomElemInput(this.inputFile);
		
		var self = this;
		this.openFileDialog = function() {
			if ( self.inputFile ) {
				self.inputFile.click();
			}
		}
		
		this.onfile;
	}
	FilesManager.prototype.setAccept = function(accept) {
		if ( this.inputFile ) {
			this.inputFile.accept = accept;
		}
	}
	FilesManager.prototype.addDomElemInput = function(elem) {
		var self = this;
		elem.addEventListener('change', function(event) {
			event.stopPropagation();  
			event.preventDefault();

			if ( this.files ) {
				self.addFiles(this.files);
			}
		});
	};
	FilesManager.prototype.addDomElemDrop = function(elem) {
		var self = this;
		
		elem.addEventListener('dragover', function(e) {
			e.stopPropagation();  
			e.preventDefault();
			e.dataTransfer.dropEffect = 'copy'; 
		});		
		
		elem.addEventListener('drop', function(event) {
			event.stopPropagation();  
			event.preventDefault();

			if ( event.dataTransfer && event.dataTransfer.files ) {
				self.addFiles(event.dataTransfer.files);
			}
		});	
	}
	FilesManager.prototype.addFile = function(file) {
		for(var i = 0; i < this.files.length; i++) {
			var f = this.files[i];
			if ( this.trySame && f.name === file.name && f.lastModified === file.lastModified &&  f.size === file.size ) {
				return;
			}
		}

		for(var i = 0, filter; filter = this.filters[i]; i++) {
			if ( !filter(file) ) {
				return;
			}
		}

		this.onfile&&this.onfile(file);
		
		this.files.push(file);
	}
	FilesManager.prototype.addFiles = function(files) {
		for(var i = 0; i < files.length; i++) {
			this.addFile(files[i]);
		}
	}
	FilesManager.prototype.addFilter = function(filter) {
		this.filters.push(filter);
	}

	return FilesManager;
	
});